# Advent 

The goal of this project is to get all 500 currently available stars in the form of one single idris application, and thoroughly document the results as literate idris files.

# Index of non-day modules

- [Runner](src/Runner.md)

  Provides data structures for structuring the division of the project into years, days, and parts.

- [Main](src/Main.md)

Provides the `Runner` based command line interface for running a selected day's solution.

- [Util](src/Util.md)

  Provides extensions of the functionality of the standard library and external libraries. Extensions to the standard library are in the base of this module.
  
  - [Util.Eff](src/Util/Eff.md)
  
    Extend the functionality of the effects included in the [eff](https://github.com/stefan-hoeck/idris2-eff/) library

# Index of years and days

- 2015
  - [Day 1](src/Years/Y2015/Day1.md)
  - [Day 2](src/Years/Y2015/Day2.md)
  - [Day 3](src/Years/Y2015/Day3.md)
  - [Day 4](src/Years/Y2015/Day4.md)
  - [Day 5](src/Years/Y2015/Day5.md)
  - [Day 6](src/Years/Y2015/Day6.md)
